﻿------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (Бурелов-СвежевательДуш) Version 1.3 (28th February 2014)
------------------------------------------------------------------------------------
--
-- Bars Colorize Module
--
------------------------------------------------------------------------------------
-- NiceColorize
------------------------------------------------------------------------------------

local Cfg = NCConfig

if Cfg.BarsColorize.ModuleEnable then
	local DefaultFont,_,_  = PlayerName:GetFont()
	local DefaultSize = 8
	local DefaultStyle = "OUTLINE"
	
	if string.upper(Cfg.BarsColorize.BarsTextFont) ~= "STANDART" then
		DefaultFont = Cfg.BarsColorize.BarsTextFont
	end
	
	if string.upper(Cfg.BarsColorize.BarsTextSize) ~= "STANDART" then
		DefaultSize = Cfg.BarsColorize.BarsTextSize
	end
	
	if string.upper(Cfg.BarsColorize.BarsTextStyle) ~= "STANDART" then
		DefaultStyle = Cfg.BarsColorize.BarsTextStyle
	end
	
	function TextOnBars_Initialization(ParentFrame, SizeX, SizeY, PointA, PointX, PointY, Font, Size, Style, Prefix)
		local MainFrame = "NC"..ParentFrame:GetName().."ScrollFrame"
		local TextFrame = "NC"..ParentFrame:GetName().."TextFrame"
		local TextPercentText = "NC"..ParentFrame:GetName().."TextFrame"..Prefix.."PercentText"
		local TextCurrentText = "NC"..ParentFrame:GetName().."TextFrame"..Prefix.."CurrentText"
		
		local MainFrame = CreateFrame("ScrollFrame", nil, ParentFrame)
		MainFrame:SetSize(SizeX, SizeY)
		MainFrame:SetPoint(PointA, PointX, PointY)

		local TextFrame = CreateFrame("Frame", nil, MainFrame)
		TextFrame:SetSize(SizeX * 2, SizeY) 
		TextFrame:SetPoint("CENTER")

		local TextPercentText = TextFrame:CreateFontString("NC"..ParentFrame:GetName().."TextFrame"..Prefix.."PercentText", "OVERLAY")
		TextPercentText:ClearAllPoints()
		TextPercentText:SetFont(Font, Size, Style)
		TextPercentText:SetWordWrap(false)

		local TextCurrentText = TextFrame:CreateFontString("NC"..ParentFrame:GetName().."TextFrame"..Prefix.."CurrentText", "OVERLAY")
		TextCurrentText:ClearAllPoints()
		TextCurrentText:SetFont(Font, Size, Style)
		TextCurrentText:SetWordWrap(false)

		MainFrame:SetScrollChild(TextFrame)
		
		return {TextPercentText, TextCurrentText}
		
	end
	
	local function TextOnBars_Update(NCBar, Bar, BarText, Unit, Alpha, Prefix, ToShow, DeathMod)
		if Prefix == "HP" then
			local MinValue, MaxValue = Bar:GetMinMaxValues()
			local Position = (Bar:GetValue() / MaxValue) * Bar:GetWidth()
			local CurHP = UnitHealth(Unit)
			local MaxHP = UnitHealthMax(Unit)
			local Pct = math.ceil(100*(CurHP / MaxHP))
			local R, G, B, _ = Bar:GetStatusBarColor()
			local NCBarPercentText, NCBarCurrentText = NCBar[1], NCBar[2]
			local Show = string.upper(ToShow)

			if not UnitIsDeadOrGhost(Unit) then
				if not BarText:GetText() then
					if (Show == "BOTH" or Show == "PERCENT") then
						NCBarPercentText:Show()
						NCBarPercentText:SetTextColor(R, G, B, Alpha)
						NCBarPercentText:SetText(format("%.0f%%",Pct))
						NCBarPercentText:SetPoint("LEFT", Bar, "LEFT", Position + 1, -0.5)
						NCBarPercentText:SetJustifyH("LEFT")
					end
					
					if (Show == "BOTH" or Show == "CURRENT") then
						NCBarCurrentText:Show()
						NCBarCurrentText:SetTextColor(R, G, B, Alpha)
						NCBarCurrentText:SetText(AbbreviateLargeNumbers(CurHP))
						NCBarCurrentText:SetPoint("RIGHT", Bar, "LEFT", Position + 1, -0.5)
						NCBarCurrentText:SetJustifyH("RIGHT")
					end
				else
					NCBarPercentText:Hide()
					NCBarCurrentText:Hide()
				end
			else
				if not BarText:GetText() then
					if DeathMod then
						NCBarPercentText:SetTextColor(R, G, B, Alpha)
						if Unit == "player" then
							NCBarPercentText:SetText(SPELL_FAILED_CASTER_DEAD)
						else
							NCBarPercentText:SetText(DEAD..".")
						end
						NCBarPercentText:ClearAllPoints()
						NCBarPercentText:SetPoint("CENTER", Bar, "CENTER", 0, -0.5)
						NCBarPercentText:SetJustifyH("LEFT")
					end
					
					NCBarCurrentText:Hide()
				else
					NCBarPercentText:Hide()
					NCBarCurrentText:Hide()
				end
			end
		elseif Prefix == "MP" then
			local MinValue, MaxValue = Bar:GetMinMaxValues()
			local Position = (Bar:GetValue() / MaxValue) * Bar:GetWidth()
			local powerType, powerToken = UnitPowerType(Unit)
			local CurPower = UnitPower(Unit)
			local MaxPower = UnitPowerMax(Unit)
			local Pct = math.ceil(100*(CurPower / MaxPower))
			local NCBarPercentText, NCBarCurrentText = NCBar[1], NCBar[2]

			if powerType == 0 then powerType = 6 end 

			local R, G, B = PowerBarColor[powerType].r, PowerBarColor[powerType].g, PowerBarColor[powerType].b

			if not UnitIsDeadOrGhost(Unit) then
				Bar:SetAlpha(1)
				if not BarText:GetText() then
					if (Show == "BOTH" or Show == "PERCENT") then
						NCBarPercentText:Show()
						NCBarPercentText:SetTextColor(R, G, B, Alpha)
						NCBarPercentText:SetText(format("%.0f%%",Pct))
						NCBarPercentText:SetPoint("LEFT", Bar, "LEFT", Position + 1, -0.5)
						NCBarPercentText:SetJustifyH("LEFT")
					end
					if (Show == "BOTH" or Show == "CURRENT") then
						NCBarCurrentText:Show()
						NCBarCurrentText:SetTextColor(R, G, B, Alpha)
						NCBarCurrentText:SetText(AbbreviateLargeNumbers(CurPower))
						NCBarCurrentText:SetPoint("RIGHT", Bar, "LEFT", Position, -0.5)
						NCBarCurrentText:SetJustifyH("RIGHT")
					end
				else
					NCBarPercentText:Hide()
					NCBarCurrentText:Hide()
				end
			else
				if DeathMod then
					Bar:SetAlpha(0)
					NCBarPercentText:Hide()
					NCBarCurrentText:Hide()
				end
			end
		end
	end
	
	local function ColorizeBars(Bar, Unit, Enable)
		if Enable then
			local CurHP = UnitHealth(Unit)
			local MaxHP = UnitHealthMax(Unit)
			local Pct = math.ceil(100*(CurHP / MaxHP))
			local R, G, B = 0, 1, 0
			
			if (Pct >= 75) then
				R, G, B = 0, 1, 0
			elseif (Pct < 75 and Pct >= 50) then
				R, G, B = 1, 1, 0
			elseif (Pct < 50 and Pct >= 25) then
				R, G, B = 1, 0.5, 0
			else
				R, G, B = 1, 0, 0
			end
			
			Bar:SetStatusBarColor(R, G, B)
		end
	end
	
	if Cfg.BarsColorize.SmoothEnable then
		SmoothFrame = CreateFrame('Frame')
		smoothing = {}

		local min, max = math.min, math.max

		local function AnimationTick()
			local limit = 30 / GetFramerate()
			for bar, value in pairs(smoothing) do
				local cur = bar:GetValue()
				local new = cur + min((value - cur) / 3, max(value-cur, limit))
				if new ~= new then
					new = value
				end
				if cur == value or abs(new - value) < 2 then
					bar:SetValue_(value)
					smoothing[bar] = nil
				else
					bar:SetValue_(new)
				end
			end
		end

		SmoothFrame:SetScript("OnUpdate", AnimationTick)

		local function SmoothSetValue(self, value)
			local _, max = self:GetMinMaxValues()
			if value == self:GetValue() or (self._max and self._max ~= max) then
				smoothing[self] = nil
				self:SetValue_(value)
			else
				smoothing[self] = value
			end
			self._max = max
		end

		for bar, value in pairs(smoothing) do
			if bar.SetValue_ then
				bar.SetValue = SmoothSetValue
			end
		end
		
		local function SmoothBar(bar)
			if not bar.SetValue_ then
				bar.SetValue_ = bar.SetValue;
				bar.SetValue = SmoothSetValue;
			end
		end

		local function ResetBar(bar)
			if bar.SetValue_ then
				bar.SetValue = bar.SetValue_;
				bar.SetValue_ = nil;
			end
		end
		
		for i, v in pairs({
			PlayerFrameHealthBar,
			PlayerFrameManaBar,
			TargetFrameHealthBar,
			TargetFrameManaBar,
			FocusFrameHealthBar,
			FocusFrameManaBar,
			TargetFrameToTHealthBar,
			TargetFrameToTManaBar,
			PartyMemberFrame1HealthBar,
			PartyMemberFrame1ManaBar,
			PartyMemberFrame2HealthBar,
			PartyMemberFrame2ManaBar,
			PartyMemberFrame3HealthBar,
			PartyMemberFrame3ManaBar,
			PartyMemberFrame4HealthBar,
			PartyMemberFrame4ManaBar,
			Boss1TargetFrameHealhBar,
			Boss1TargetFrameManaBar,
			Boss2TargetFrameHealhBar,
			Boss2TargetFrameManaBar,
			Boss3TargetFrameHealhBar,
			Boss3TargetFrameManaBar,
			Boss4TargetFrameHealhBar,
			Boss4TargetFrameManaBar,
			Boss5TargetFrameHealhBar,
			Boss5TargetFrameManaBar,
			ArenaEnemyFrame1HealthBar,
			ArenaEnemyFrame1ManaBar,
			ArenaEnemyFrame2HealthBar,
			ArenaEnemyFrame2ManaBar,
			ArenaEnemyFrame3HealthBar,
			ArenaEnemyFrame3ManaBar,
			ArenaEnemyFrame4HealthBar,
			ArenaEnemyFrame4ManaBar,
			ArenaEnemyFrame5HealthBar,
			ArenaEnemyFrame5ManaBar,
			PetFrameHealthBar,
			PetFrameManaBar,
			}) do
				SmoothBar(v)
		end
		
	--[[	for i=1, MAX_RAID_MEMBERS do
			if _G["CompactRaidFrame"..i] then
				SmoothBar(_G["CompactRaidFrame"..i.."HealthBar"])
			end
		end ]]--
	end
	
	NCPlayerHPText = TextOnBars_Initialization(PlayerFrame, 119, 12, "TOPLEFT", 106, -41, DefaultFont, DefaultSize, DefaultStyle, "HP")
	NCPlayerMPText = TextOnBars_Initialization(PlayerFrame, 119, 12, "TOPLEFT", 106, -52, DefaultFont, DefaultSize, DefaultStyle, "MP")
	
	NCTargetHPText = TextOnBars_Initialization(TargetFrame, 119, 12, "TOPRIGHT", -106, -41, DefaultFont, DefaultSize, DefaultStyle, "HP")
	NCTargetMPText = TextOnBars_Initialization(TargetFrame, 119, 12, "TOPRIGHT", -106, -52, DefaultFont, DefaultSize, DefaultStyle, "MP")
	
	NCFocusHPText = TextOnBars_Initialization(FocusFrame, 119, 12, "TOPRIGHT", -106, -41, DefaultFont, DefaultSize, DefaultStyle, "HP")
	NCFocusMPText = TextOnBars_Initialization(FocusFrame, 119, 12, "TOPRIGHT", -106, -52, DefaultFont, DefaultSize, DefaultStyle, "MP")
	
	PlayerFrameMyHealPredictionBar:SetParent(PlayerFrameHealthBar)
	PlayerFrameOtherHealPredictionBar:SetParent(PlayerFrameHealthBar)
	PlayerFrameHealAbsorbBar:SetParent(PlayerFrameHealthBar)
	PlayerFrameHealAbsorbBarLeftShadow:SetParent(PlayerFrameHealthBar)
	PlayerFrameHealAbsorbBarRightShadow:SetParent(PlayerFrameHealthBar)

	for i, v in pairs({
			PlayerFrameHealthBar,
			TargetFrameHealthBar,
			FocusFrameHealthBar,
			TargetFrameToTHealthBar,
			PartyMemberFrame1HealthBar,
			PartyMemberFrame2HealthBar,
			PartyMemberFrame3HealthBar,
			PartyMemberFrame4HealthBar,
			Boss1TargetFrameHealhBar,
			Boss2TargetFrameHealhBar,
			Boss3TargetFrameHealhBar,
			Boss4TargetFrameHealhBar,
			Boss5TargetFrameHealhBar,
			ArenaEnemyFrame1HealthBar,
			ArenaEnemyFrame2HealthBar,
			ArenaEnemyFrame3HealthBar,
			ArenaEnemyFrame4HealthBar,
			ArenaEnemyFrame5HealthBar,
			PetFrameHealthBar,
			}) do
				v.lockColor = Cfg.BarsColorize.BarsColorizeEnable
		end
	
	local NCBarFrame = CreateFrame('Frame')
	NCBarFrame:SetScript("OnUpdate", function()
		if PlayerFrame:IsShown() then
			ColorizeBars(PlayerFrameHealthBar, "player", Cfg.BarsColorize.BarsColorizeEnable)
			TextOnBars_Update(NCPlayerHPText, PlayerFrameHealthBar, PlayerFrameHealthBarText, "player", Cfg.BarsColorize.TextAlpha, "HP", Cfg.BarsColorize.PlayerHealthBarText, Cfg.BarsColorize.PlayerBarsDeathMod)
			TextOnBars_Update(NCPlayerMPText, PlayerFrameManaBar, PlayerFrameManaBarText, "player", Cfg.BarsColorize.TextAlpha, "MP", Cfg.BarsColorize.PlayerPowerBarText, Cfg.BarsColorize.PlayerBarsDeathMod)
		end
		
		if TargetFrame:IsShown() then
			if TargetFrameTextureFrameDeadText:GetText() then TargetFrameTextureFrameDeadText:Hide() end
			ColorizeBars(TargetFrameHealthBar, "target", Cfg.BarsColorize.BarsColorizeEnable)
			TextOnBars_Update(NCTargetHPText, TargetFrameHealthBar, TargetFrameTextureFrameHealthBarText, "target", Cfg.BarsColorize.TextAlpha, "HP", Cfg.BarsColorize.TargetHealthBarText, Cfg.BarsColorize.TargetBarsDeathMod)
			TextOnBars_Update(NCTargetMPText, TargetFrameManaBar, TargetFrameTextureFrameManaBarText, "target", Cfg.BarsColorize.TextAlpha, "MP", Cfg.BarsColorize.TargetPowerBarText, Cfg.BarsColorize.TargetBarsDeathMod)
		end
		
		if FocusFrame:IsShown() then
			if FocusFrameTextureFrameDeadText:GetText() then FocusFrameTextureFrameDeadText:Hide() end
			ColorizeBars(FocusFrameHealthBar, "focus", Cfg.BarsColorize.BarsColorizeEnable)
			TextOnBars_Update(NCFocusHPText, FocusFrameHealthBar, FocusFrameTextureFrameHealthBarText, "focus", Cfg.BarsColorize.TextAlpha, "HP", Cfg.BarsColorize.FocusHealthBarText, Cfg.BarsColorize.FocusBarsDeathMod)
			TextOnBars_Update(NCFocusMPText, FocusFrameManaBar, FocusFrameTextureFrameManaBarText, "focus", Cfg.BarsColorize.TextAlpha, "MP", Cfg.BarsColorize.FocusPowerBarText, Cfg.BarsColorize.FocusBarsDeathMod)
		end
		
		if TargetFrameToT:IsShown() then
			ColorizeBars(TargetFrameToTHealthBar, "targettarget", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if PartyMemberFrame1:IsShown() then
			ColorizeBars(PartyMemberFrame1HealthBar, "party1", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if PartyMemberFrame2:IsShown() then
			ColorizeBars(PartyMemberFrame2HealthBar, "party2", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if PartyMemberFrame3:IsShown() then
			ColorizeBars(PartyMemberFrame3HealthBar, "party3", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if PartyMemberFrame4:IsShown() then
			ColorizeBars(PartyMemberFrame4HealthBar, "party4", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame1 then
			ColorizeBars(ArenaEnemyFrame1HealthBar, "arena1", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame2 then
			ColorizeBars(ArenaEnemyFrame2HealthBar, "arena2", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame3 then
			ColorizeBars(ArenaEnemyFrame3HealthBar, "arena3", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame4 then
			ColorizeBars(ArenaEnemyFrame4HealthBar, "arena4", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if ArenaEnemyFrame5 then
			ColorizeBars(ArenaEnemyFrame5HealthBar, "arena5", Cfg.BarsColorize.BarsColorizeEnable)
		end
		
		if PetFrame:IsShown() then
			ColorizeBars(PetFrameHealthBar, "pet", Cfg.BarsColorize.BarsColorizeEnable)
		end
	end)
end